#region License
// Product:
// MCM (Message-Command-Message)
// mcm-framework.net
// 
// Author:
// Pawel Idzikowski
// Cologne, Germany
// idzikowski@polenter.com
// 
// This software is provided 'as-is', without any express or implied warranty.
// In no event will the author(s) be held liable for any damages arising from
// the use of this software.
// 
// Permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions:
// 
//     1. The origin of this software must not be misrepresented; you must not
//       claim that you wrote the original software. If you use this software
//       in a product, an acknowledgment in the product documentation would be
//       appreciated but is not required.
// 
//     2. Altered source versions must be plainly marked as such, and must not
//       be misrepresented as being the original software.
// 
//     3. This notice may not be removed or altered from any source distribution.
// 
#endregion
namespace Polenter.Mcm.Advanced
{
    /// <summary>
    /// Could be a memory queue or a persistent one. 
    /// Thread safety is not required.
    /// </summary>
    public interface IQueue
    {
        ///<summary>
        /// How many items there are in the queue
        ///</summary>
        int Count { get; }

        ///<summary>
        /// Adds one element at the end of the queue
        ///</summary>
        ///<param name="item"></param>
        void Enqueue(object item);

        ///<summary>
        /// Gets the first item from the queue and removes it from the queue
        ///</summary>
        ///<returns></returns>
        object Dequeue();

        ///<summary>
        /// Clears the queue
        ///</summary>
        void Clear();

        ///<summary>
        /// Gets all items as an array but does not clear the queue
        ///</summary>
        ///<returns></returns>
        object[] ToArray();
    }
}