#region License
// Product:
// MCM (Message-Command-Message)
// mcm-framework.net
// 
// Author:
// Pawel Idzikowski
// Cologne, Germany
// idzikowski@polenter.com
// 
// This software is provided 'as-is', without any express or implied warranty.
// In no event will the author(s) be held liable for any damages arising from
// the use of this software.
// 
// Permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions:
// 
//     1. The origin of this software must not be misrepresented; you must not
//       claim that you wrote the original software. If you use this software
//       in a product, an acknowledgment in the product documentation would be
//       appreciated but is not required.
// 
//     2. Altered source versions must be plainly marked as such, and must not
//       be misrepresented as being the original software.
// 
//     3. This notice may not be removed or altered from any source distribution.
// 
#endregion
using System.Collections;

namespace Polenter.Mcm.Advanced
{
    /// <summary>
    /// Wrapper on the .NET Queue supporting IQueue
    /// </summary>
    internal class SimpleQueue : IQueue
    {
        private readonly Queue _queue = new Queue();

        #region IQueue Members

        /// <summary>
        /// Adds one item to the queue
        /// </summary>
        /// <param name="item"></param>
        public void Enqueue(object item)
        {
            _queue.Enqueue(item);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns>null if there is nothing more on the queue</returns>
        public object Dequeue()
        {
            return _queue.Dequeue();
        }

        public void Clear()
        {
            _queue.Clear();
        }

        public object[] ToArray()
        {
            return _queue.ToArray();
        }

        public int Count
        {
            get { return _queue.Count; }
        }

        #endregion
    }
}